//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         vline.h
//   
// PURPOSE:      Header file for VLINE subclass EuroCtrl project
//   
// COMMENTS:     
//   
// HISTORY:      920525AH Prehistory
//   
//****************************************************************************                    



#define VLINE_BACKGROUND_DEFAULT    GREY

// Default Width & Height
#define	HLINE_DEFAULTHEIGHT	90
#define HLINE_DEFAULTWIDTH	2 

//---------------------------------------------------------------------------
// VLINE control data and structs
//---------------------------------------------------------------------------
typedef struct tagVLINE
{                     
    HSZ		hszabout;
    ENUM	LineStyle;		// Style of lines
    ENUM	Line3DStyle;	// 3D Style of lines
	SHORT	LineWidth;		// width of lines
} VLINE;

typedef VLINE FAR * PVLINE;

#define VLINEDEREF(hctl)     ((PVLINE)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export VlineCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_VLINE_NAME            0
#define IPROP_VLINE_INDEX           1
#define IPROP_VLINE_PARENT          2
#define IPROP_VLINE_BACKCOLOR       3
#define IPROP_VLINE_LEFT            4
#define IPROP_VLINE_TOP             5
#define IPROP_VLINE_WIDTH           6
#define IPROP_VLINE_HEIGHT          7
#define IPROP_VLINE_ENABLED         8
#define IPROP_VLINE_VISIBLE         9
#define IPROP_VLINE_MOUSEPOINTER    10
#define IPROP_VLINE_LINE3DSTYLE		11
#define IPROP_VLINE_FORECOLOR       12 
#define IPROP_VLINE_ABOUT			13
#define IPROP_VLINE_LINESTYLE		14
#define IPROP_VLINE_LINEWIDTH		15
#define IPROP_VLINE_HWND			16

#ifdef CTL_DATA                       

PROPINFO Property_Vline_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(VLINE, hszabout)
}; 

PROPINFO propinfoVlineLine3DStyle =
{
    "Style3D",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(VLINE,Line3DStyle), 0,
    0,
    "0 - No 3D effect.\0"
    "1 - Carved.\0"
    "2 - Raised.\0",
    LINESTYLE3DRAISED
};    

PROPINFO propinfoVlineLineStyle =
{
    "Style",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(VLINE,LineStyle), 0,
    0,
    "0 - Solid Line.\0"
    "1 - Dash.\0"
    "2 - Dot.\0"
    "3 - Dash Dot.\0"
    "4 - Dash Dot Dot.\0",
    LINESTYLEDASHDOTDOT
};
             
PROPINFO propinfoVlineLineWidth =
{
    "LineWidth",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(VLINE,LineWidth), 0
}; 

PROPINFO propinfoVlinehWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
}; 

PPROPINFO proplistVline[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_MOUSEPOINTER,
    &propinfoVlineLine3DStyle,
    PPROPINFO_STD_FORECOLOR,
    &Property_Vline_About,            
    &propinfoVlineLineStyle,
    &propinfoVlineLineWidth,
    &propinfoVlinehWnd,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define EVENT_VLINE_DRAGDROP    0
#define EVENT_VLINE_DRAGOVER    1

#ifdef CTL_DATA
PEVENTINFO eventlistVline[] =
{
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelVline =
{
    VB_VERSION,                 // VB version being used
    MODEL_fDesInteract | MODEL_fFocusOk | MODEL_fChildrenOk,          // MODEL flags
    (PCTLPROC)VlineCtlProc,     // Control procedure
    CS_VREDRAW | CS_HREDRAW,    // Class style
    NULL,                 		// Default Window style
    sizeof(VLINE),              // cbCtlExtra for VLINE structure
    IDBMP_VLINE,                // Palette bitmap ID
    "EsHLine",		       		// Default control name
    "EsVline",		       		// Visual Basic class name
    NULL,                   	// Parent class name
    proplistVline,              // Properties list
    eventlistVline,             // Events list
	IPROP_VLINE_LINEWIDTH,		// default property in code window
	EVENT_VLINE_DRAGDROP,		// default event in code window
	IPROP_VLINE_LINEWIDTH		// standard property	
};
#endif  // CTL_DATA

LPMODEL modellistVline[] =
    {
    &modelVline,
    NULL
    };

MODELINFO modelinfoVline =
    {
    VB_VERSION, 			// VB version being used
    modellistVline			// MODEL list
    };


#endif  // RC_INVOKED
